#ifndef SMART_THERMOMETER_H_
#define SMART_THERMOMETER_H_

// --------------------------------------------------------------------------
typedef struct {
	uint32_t up_time;			// uptime [s]
	int16_t voltage;			// napeti na baterii
	int16_t temperature_in;
	uint16_t humidity_in;
	int32_t pressure_in;
	int16_t temperature_in_max;
	uint16_t humidity_in_max;
	int32_t pressure_in_max;
	int16_t temperature_in_min;
	uint16_t humidity_in_min;
	int32_t pressure_in_min;

	int16_t temperature_out;
	uint16_t humidity_out;
	int32_t pressure_out;
	int16_t temperature_out_max;
	uint16_t humidity_out_max;
	int32_t pressure_out_max;
	int16_t temperature_out_min;
	uint16_t humidity_out_min;
	int32_t pressure_out_min;
	uint32_t rtc_time;

	unsigned
		server_connected: 1,
		reserved: 7;

} TState;

typedef struct {
	int16_t temperature_in;
	uint16_t humidity_in;
	int32_t pressure_in;
	int16_t temperature_out;
	uint16_t humidity_out;
	int32_t pressure_out;
} TMeasureRec;


#endif /* SMART_THERMOMETER_H_ */
