#ifndef _DI_ADC
#define _DI_ADC

#include "main.h"

// --------------------------------------------------------------------------
#ifndef ADC_CHANGE_NAMUR
#define ADC_CHANGE_NAMUR()
#endif

// --------------------------------------------------------------------------
#ifndef ADC_SAMPLE_PERIOD
#define ADC_SAMPLE_PERIOD			500	// [ms]
#endif

// --------------------------------------------------------------------------
#define ADC_BATTERY					27			// Bandgap measurement
#define ADC_CH_BATTERY				(1 << ADC_BATTERY)		// 5b

#define ADC_VREF					3000.0	// [mV]
#define ADC_BAT_DIVIDER(r1, r2)		(ADC_VREF / ((65535 * r2) / (r1 + r2)))

// --------------------------------------------------------------------------
typedef struct {
	volatile unsigned int tmr_measure;		// timer pro opakovani mereni
	volatile unsigned char nam;				// aktualni stav namuru pro porovnani zmeny
	bool adc_running;						// spusteni adc mereni
} ADC_work_struct;

// --------------------------------------------------------------------------
extern void adc_init(void);
extern void adc_handle(void);
extern void adc_run(void);
extern bool adc_get_running(void);
extern bool adc_check_battery(void);

// --------------------------------------------------------------------------
#ifndef adc_printf
#define adc_printf(...)
#endif


#endif // _DI_ADC
