#ifndef __FSL_ADC_H__
#define __FSL_ADC_H__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdint.h>
#include <fsl_adc16_hal.h>

#ifdef __cplusplus
extern "C" {
#endif

// --------------------------------------------------------------------------
// Options
#ifndef ADC_RESOLUTION
#define ADC_RESOLUTION			kAdc16ResolutionBitOf12or13
#endif
#ifndef ADC_REFERENCE
#define ADC_REFERENCE			kAdc16RefVoltSrcOfVref
#endif

// --------------------------------------------------------------------------
// Functions
void init_adc(adc16_clk_divider_t clkDiv, bool lowPower);
void stop_adc(void);
#if FSL_FEATURE_ADC16_HAS_DIFF_MODE
bool run_adc(uint32_t channels, uint32_t differential);
#else
bool run_adc(uint32_t channels);
#endif
#if FSL_FEATURE_ADC16_HAS_HW_AVERAGE
void set_adc_averaging(bool enable, adc16_hw_average_count_t mode);
#endif

uint16_t get_adc(uint32_t channel);
bool get_adc_done(void);

#ifdef __cplusplus
}
#endif

#endif /* __FSL_ADC_H__ */
