/*
 * e_ink_display.h
 *
 * Created: 22.12.2017 19:43:00
 *  Author: ondra
 */ 


#ifndef E_INK_DISPLAY_H_
#define E_INK_DISPLAY_H_

// Eink Commands
#define ECMD_DRIVE_OUT				0x01
#define ECMD_BOOST_SOFT_START		0x0C
#define ECMD_DEEP_SLEEP				0x10
#define ECMD_DATA_ENTRY_MODE		0x11
#define ECMD_SW_RESET				0x12
#define ECMD_TEMP_SENSOR			0x1A
#define ECMD_MASTER_ACTIVATION		0x20		// Activate Display Update sequence
#define ECMD_DISPLAY_UPDATE_CTRL1	0x21
#define ECMD_DISPLAY_UPDATE_CTRL2	0x22
#define ECMD_WRITE_RAM				0x24
#define ECMD_WRITE_VCOM				0x2C
#define ECMD_WRITE_LUT_REG			0x32
#define ECMD_SET_DUMMY_LINE_PER		0x3A
#define ECMD_SET_GATE_LINE_WIDTH	0x3B
#define ECMD_BORDER_WAVEFORM		0x3C
#define ECMD_SET_RAM_X_START_END	0x44
#define ECMD_SET_RAM_Y_START_END	0x45
#define ECMD_SET_RAM_X				0x4E
#define ECMD_SET_RAM_Y				0x4F
#define ECMD_NOP					0xFF

extern const unsigned char lut_full_update[];
extern const unsigned char lut_partial_update[];

void Epd_SendCommand(unsigned char cmd);
void Epd_SendData(unsigned char data);
void Epd_WaitUntilIdle(void);
void Epd_Reset(void);
void Epd_SetLut(const unsigned char* lut);
void Epd_SetFrameMemoryPart(unsigned char* image_buffer, int x, int y, int image_width, int image_height);
void Epd_SetFrameMemory(const unsigned char* image_buffer);
void Epd_ClearFrameMemory(unsigned char color);
void Epd_DisplayFrame(void);
void Epd_SetMemoryArea(int x_start, int y_start, int x_end, int y_end);
void Epd_SetMemoryPointer(int x, int y);
void Epd_Sleep();
int Epd_Init(const unsigned char* lut);

#endif /* E_INK_DISPLAY_H_ */